[tool.poetry]
name = "schema-provider-from-linkml"
version = "0.1.0"
description = "Linkml gaia-x generation"
authors = ["OVH Cloud"]
license = "Apache-2.0"
readme = "README.md"

[tool.poetry.dependencies]
python = "^3.10"
linkml = "^1.6.1"
pyshacl = "^0.23.0"
mkdocs = "^1.4.2"
mkdocs-mermaid2-plugin = "^1.0.8"
mkdocs-material = "9.*"

[tool.poetry.group.dev.dependencies]
pylint = "^2.17.4"
isort = "^5.12.0"
black = "^23.3.0"
ruff = "^0.0.267"
colorama = "^0.4.6"

[build-system]
requires = ["poetry-core"]
build-backend = "poetry.core.masonry.api"

[tool.isort]
profile = "black"
known_third_party = ["linkml", "pyshacl"]
src_paths = ["src", "tests"]
no_lines_before="LOCALFOLDER"
use_parentheses=true
include_trailing_comma=true
color_output=true

[tool.black]
line-length = 120
target-version = ['py310']
include = '(catalogue|tests)\/.*(\.py)'
include_trailing_comma = false
exclude='''
(
  /(
      \.eggs         # exclude a few common directories in the
    | \.eggs-info
    | \.git          # root of the project
    | \.tox
    | \.venv
    | \.sha1
    | \.direnv/python_venv
    | \.direnv/.sha1
    | python_venv
    | build
    | dist
    | site
    | site.tox
  )/
)
'''

[tool.ruff]
line-length = 120
src = ["catalogue"]
exclude = [".bzr", ".direnv", ".eggs", ".git", ".git-rewrite", ".hg", ".mypy_cache", ".nox", ".pants.d", ".pytype", ".ruff_cache", ".svn", ".tox", ".venv", "__pypackages__", "_build", "buck-out", "build", "dist", "node_modules", "venv", "tests"]

select = [
    "E",  # pycodestyle
    "F",  # pyflakes
    "W",  # pycodestyle
    "B",  # bugbear
    "I",  # isort
    "S",  # flake8-bandit
    "RUF", # ruff
]

fixable = [
    "E",  # pycodestyle
    "F",  # pyflakes
    "W",  # pycodestyle
    "B",  # bugbear
    "I",  # isort
    "S",  # flake8-bandit
    "RUF", # ruff
]

ignore = [
    "RUF008",
    "RUF009",
    "S104",
    "E501"
]

[tool.ruff.pydocstyle]
convention = "google"
